import { TableState } from 'react-table';

export function getStorageInitialState<T extends Record<string, any>>(
  localStorageKey: string
) {
  const initState: Partial<TableState<T>> = {};
  const showColumn = localStorage.getItem(localStorageKey + '_columnOrder')
    ? JSON.parse(
        localStorage.getItem(localStorageKey + '_columnOrder') as string
      )
    : undefined;
  if (showColumn) initState['columnOrder'] = showColumn;

  const hideColumn = localStorage.getItem(localStorageKey + '_hiddenColumns')
    ? JSON.parse(
        localStorage.getItem(localStorageKey + '_hiddenColumns') as string
      )
    : undefined;
  if (hideColumn) initState['hiddenColumns'] = hideColumn;

  return initState;
}
