import { CellProps, Hooks } from 'react-table';
import React from 'react';
import KeyboardArrowDownIcon from '@material-ui/icons/KeyboardArrowDown';
import KeyboardArrowRightIcon from '@material-ui/icons/KeyboardArrowRight';
import styles from 'EnhancedTable.module.scss';

export default (hooks: Hooks<any>) => {
  hooks.allColumns.unshift((columns) => [
    {
      id: '_aggression',
      disableResizing: true,
      disableGroupBy: true,
      minWidth: 45,
      width: 45,
      maxWidth: 45,
      Cell: ({ row }: CellProps<any>) => (
        <div>
          {row.isGrouped && (
            <span className={styles.headerCell}>
              <span
                className="dflex-center"
                {...row.getToggleRowExpandedProps()}
              >
                {row.isExpanded ? (
                  <KeyboardArrowDownIcon />
                ) : (
                  <KeyboardArrowRightIcon />
                )}
              </span>
            </span>
          )}
        </div>
      ),
      disableSortBy: true,
    },
    ...columns,
  ]);
  hooks.useInstanceBeforeDimensions.push(({ headerGroups }) => {
    // fix the parent group of the selection button to not be resizable
    const selectionGroupHeader = headerGroups[0].headers[0];
    selectionGroupHeader.canResize = false;
  });
};
