import { Hooks, TableInstance } from 'react-table';
import { useMemo } from 'react';

/**

/**
 * Modified part
 * Add function setSticky for column
 */
function useInstance(instance: TableInstance) {
  const { totalColumnsWidth, visibleColumns } = instance;

  const totalVisibleColumnsWidth = useMemo(
    () =>
      totalColumnsWidth -
      visibleColumns
        .filter((column) => column.isHidden)
        .reduce((sum, column) => (sum += Number(column.width)), 0),
    [totalColumnsWidth, visibleColumns]
  );

  Object.assign(instance, {
    totalVisibleColumnsWidth,
  });
}

export const useHiddenColumn = (hooks: Hooks<any>) => {
  hooks.useInstance.push(useInstance);
};

useHiddenColumn.pluginName = 'useLocalStorageTable';
